---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for FMC masterFIP core registers
---------------------------------------------------------------------------------------
-- File           : masterfip_wbgen2_csr.vhd
-- Author         : auto-generated by wbgen2 from masterfip_csr.wb
-- Created        : 05/31/18 17:36:43
-- Version        : 0x00020100
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE masterfip_csr.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.masterfip_wbgen2_pkg.all;


entity masterfip_wbgen2_csr is
  port (
    rst_n_i                                  : in     std_logic;
    clk_sys_i                                : in     std_logic;
    wb_adr_i                                 : in     std_logic_vector(7 downto 0);
    wb_dat_i                                 : in     std_logic_vector(31 downto 0);
    wb_dat_o                                 : out    std_logic_vector(31 downto 0);
    wb_cyc_i                                 : in     std_logic;
    wb_sel_i                                 : in     std_logic_vector(3 downto 0);
    wb_stb_i                                 : in     std_logic;
    wb_we_i                                  : in     std_logic;
    wb_ack_o                                 : out    std_logic;
    wb_stall_o                               : out    std_logic;
    regs_i                                   : in     t_masterfip_in_registers;
    regs_o                                   : out    t_masterfip_out_registers
  );
end masterfip_wbgen2_csr;

architecture syn of masterfip_wbgen2_csr is

signal masterfip_ver_id_int                     : std_logic_vector(31 downto 0);
signal masterfip_rst_core_dly0                  : std_logic      ;
signal masterfip_rst_core_int                   : std_logic      ;
signal masterfip_rst_fd_dly0                    : std_logic      ;
signal masterfip_rst_fd_int                     : std_logic      ;
signal masterfip_led_rx_act_int                 : std_logic      ;
signal masterfip_led_rx_err_int                 : std_logic      ;
signal masterfip_led_tx_act_int                 : std_logic      ;
signal masterfip_led_tx_err_int                 : std_logic      ;
signal masterfip_led_ext_sync_act_int           : std_logic      ;
signal masterfip_led_ext_sync_err_int           : std_logic      ;
signal masterfip_led_dbg_int                    : std_logic_vector(23 downto 0);
signal masterfip_ext_sync_ctrl_term_en_int      : std_logic      ;
signal masterfip_ext_sync_ctrl_dir_int          : std_logic      ;
signal masterfip_ext_sync_ctrl_oe_n_int         : std_logic      ;
signal masterfip_ext_sync_ctrl_p_cnt_rst_int    : std_logic      ;
signal masterfip_ext_sync_ctrl_opt_int          : std_logic      ;
signal masterfip_ext_sync_ctrl_safe_wind_int    : std_logic      ;
signal masterfip_macrocyc_lgth_int              : std_logic_vector(30 downto 0);
signal masterfip_macrocyc_start_dly0            : std_logic      ;
signal masterfip_macrocyc_start_int             : std_logic      ;
signal masterfip_turnar_lgth_int                : std_logic_vector(30 downto 0);
signal masterfip_turnar_start_dly0              : std_logic      ;
signal masterfip_turnar_start_int               : std_logic      ;
signal masterfip_silen_lgth_int                 : std_logic_vector(30 downto 0);
signal masterfip_silen_start_dly0               : std_logic      ;
signal masterfip_silen_start_int                : std_logic      ;
signal masterfip_tx_ctrl_rst_dly0               : std_logic      ;
signal masterfip_tx_ctrl_rst_int                : std_logic      ;
signal masterfip_tx_ctrl_start_dly0             : std_logic      ;
signal masterfip_tx_ctrl_start_int              : std_logic      ;
signal masterfip_tx_ctrl_bytes_num_int          : std_logic_vector(15 downto 0);
signal masterfip_rx_ctrl_rst_dly0               : std_logic      ;
signal masterfip_rx_ctrl_rst_int                : std_logic      ;
signal masterfip_tx_payld_ctrl_int              : std_logic_vector(7 downto 0);
signal masterfip_tx_payld_reg1_int              : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg2_int              : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg3_int              : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg4_int              : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg5_int              : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg6_int              : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg7_int              : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg8_int              : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg9_int              : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg10_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg11_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg12_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg13_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg14_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg15_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg16_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg17_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg18_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg19_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg20_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg21_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg22_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg23_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg24_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg25_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg26_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg27_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg28_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg29_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg30_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg31_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg32_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg33_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg34_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg35_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg36_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg37_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg38_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg39_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg40_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg41_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg42_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg43_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg44_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg45_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg46_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg47_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg48_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg49_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg50_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg51_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg52_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg53_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg54_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg55_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg56_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg57_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg58_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg59_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg60_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg61_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg62_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg63_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg64_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg65_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg66_int             : std_logic_vector(31 downto 0);
signal masterfip_tx_payld_reg67_int             : std_logic_vector(31 downto 0);
signal ack_sreg                                 : std_logic_vector(9 downto 0);
signal rddata_reg                               : std_logic_vector(31 downto 0);
signal wrdata_reg                               : std_logic_vector(31 downto 0);
signal rwaddr_reg                               : std_logic_vector(7 downto 0);
signal ack_in_progress                          : std_logic      ;

begin
-- Some internal signals assignments
  wrdata_reg <= wb_dat_i;
-- 
-- Main register bank access process.
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      ack_sreg <= "0000000000";
      ack_in_progress <= '0';
      rddata_reg <= "00000000000000000000000000000000";
      masterfip_ver_id_int <= "00000000000000100000000100000000";
      masterfip_rst_core_int <= '0';
      masterfip_rst_fd_int <= '0';
      masterfip_led_rx_act_int <= '0';
      masterfip_led_rx_err_int <= '0';
      masterfip_led_tx_act_int <= '0';
      masterfip_led_tx_err_int <= '0';
      masterfip_led_ext_sync_act_int <= '0';
      masterfip_led_ext_sync_err_int <= '0';
      masterfip_led_dbg_int <= "000000000000000000000000";
      masterfip_ext_sync_ctrl_term_en_int <= '0';
      masterfip_ext_sync_ctrl_dir_int <= '0';
      masterfip_ext_sync_ctrl_oe_n_int <= '0';
      masterfip_ext_sync_ctrl_p_cnt_rst_int <= '0';
      masterfip_ext_sync_ctrl_opt_int <= '0';
      masterfip_ext_sync_ctrl_safe_wind_int <= '0';
      masterfip_macrocyc_lgth_int <= "0000000000000000000000000000000";
      masterfip_macrocyc_start_int <= '0';
      masterfip_turnar_lgth_int <= "0000000000000000000000000000000";
      masterfip_turnar_start_int <= '0';
      masterfip_silen_lgth_int <= "0000000000000000000000000000000";
      masterfip_silen_start_int <= '0';
      masterfip_tx_ctrl_rst_int <= '0';
      masterfip_tx_ctrl_start_int <= '0';
      masterfip_tx_ctrl_bytes_num_int <= "0000000000000000";
      masterfip_rx_ctrl_rst_int <= '0';
      masterfip_tx_payld_ctrl_int <= "00000000";
      masterfip_tx_payld_reg1_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg2_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg3_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg4_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg5_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg6_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg7_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg8_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg9_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg10_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg11_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg12_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg13_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg14_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg15_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg16_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg17_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg18_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg19_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg20_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg21_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg22_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg23_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg24_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg25_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg26_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg27_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg28_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg29_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg30_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg31_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg32_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg33_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg34_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg35_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg36_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg37_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg38_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg39_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg40_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg41_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg42_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg43_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg44_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg45_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg46_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg47_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg48_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg49_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg50_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg51_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg52_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg53_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg54_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg55_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg56_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg57_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg58_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg59_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg60_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg61_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg62_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg63_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg64_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg65_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg66_int <= "00000000000000000000000000000000";
      masterfip_tx_payld_reg67_int <= "00000000000000000000000000000000";
    elsif rising_edge(clk_sys_i) then
-- advance the ACK generator shift register
      ack_sreg(8 downto 0) <= ack_sreg(9 downto 1);
      ack_sreg(9) <= '0';
      if (ack_in_progress = '1') then
        if (ack_sreg(0) = '1') then
          masterfip_rst_core_int <= '0';
          masterfip_rst_fd_int <= '0';
          masterfip_macrocyc_start_int <= '0';
          masterfip_turnar_start_int <= '0';
          masterfip_silen_start_int <= '0';
          masterfip_tx_ctrl_rst_int <= '0';
          masterfip_tx_ctrl_start_int <= '0';
          masterfip_rx_ctrl_rst_int <= '0';
          ack_in_progress <= '0';
        else
        end if;
      else
        if ((wb_cyc_i = '1') and (wb_stb_i = '1')) then
          case rwaddr_reg(7 downto 0) is
          when "00000000" => 
            if (wb_we_i = '1') then
              masterfip_ver_id_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_ver_id_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00000001" => 
            if (wb_we_i = '1') then
              masterfip_rst_core_int <= wrdata_reg(0);
              masterfip_rst_fd_int <= wrdata_reg(1);
            end if;
            rddata_reg(0) <= '0';
            rddata_reg(1) <= '0';
            rddata_reg(0) <= 'X';
            rddata_reg(1) <= 'X';
            rddata_reg(2) <= 'X';
            rddata_reg(3) <= 'X';
            rddata_reg(4) <= 'X';
            rddata_reg(5) <= 'X';
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(2) <= '1';
            ack_in_progress <= '1';
          when "00000010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= "11000000000000001111111111101110";
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00000011" => 
            if (wb_we_i = '1') then
              masterfip_led_rx_act_int <= wrdata_reg(0);
              masterfip_led_rx_err_int <= wrdata_reg(1);
              masterfip_led_tx_act_int <= wrdata_reg(2);
              masterfip_led_tx_err_int <= wrdata_reg(3);
              masterfip_led_ext_sync_act_int <= wrdata_reg(4);
              masterfip_led_ext_sync_err_int <= wrdata_reg(5);
              masterfip_led_dbg_int <= wrdata_reg(31 downto 8);
            end if;
            rddata_reg(0) <= masterfip_led_rx_act_int;
            rddata_reg(1) <= masterfip_led_rx_err_int;
            rddata_reg(2) <= masterfip_led_tx_act_int;
            rddata_reg(3) <= masterfip_led_tx_err_int;
            rddata_reg(4) <= masterfip_led_ext_sync_act_int;
            rddata_reg(5) <= masterfip_led_ext_sync_err_int;
            rddata_reg(31 downto 8) <= masterfip_led_dbg_int;
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00000100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(15 downto 0) <= regs_i.ds1820_temper_i;
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00000101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.ds1820_id_lsb_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00000110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.ds1820_id_msb_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00000111" => 
            if (wb_we_i = '1') then
              masterfip_ext_sync_ctrl_term_en_int <= wrdata_reg(0);
              masterfip_ext_sync_ctrl_dir_int <= wrdata_reg(1);
              masterfip_ext_sync_ctrl_oe_n_int <= wrdata_reg(2);
              masterfip_ext_sync_ctrl_p_cnt_rst_int <= wrdata_reg(8);
              masterfip_ext_sync_ctrl_opt_int <= wrdata_reg(16);
              masterfip_ext_sync_ctrl_safe_wind_int <= wrdata_reg(24);
            end if;
            rddata_reg(0) <= masterfip_ext_sync_ctrl_term_en_int;
            rddata_reg(1) <= masterfip_ext_sync_ctrl_dir_int;
            rddata_reg(2) <= masterfip_ext_sync_ctrl_oe_n_int;
            rddata_reg(8) <= masterfip_ext_sync_ctrl_p_cnt_rst_int;
            rddata_reg(16) <= masterfip_ext_sync_ctrl_opt_int;
            rddata_reg(24) <= masterfip_ext_sync_ctrl_safe_wind_int;
            rddata_reg(3) <= 'X';
            rddata_reg(4) <= 'X';
            rddata_reg(5) <= 'X';
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00001000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.ext_sync_p_cnt_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00001001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(1 downto 0) <= regs_i.speed_i;
            rddata_reg(2) <= 'X';
            rddata_reg(3) <= 'X';
            rddata_reg(4) <= 'X';
            rddata_reg(5) <= 'X';
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00001010" => 
            if (wb_we_i = '1') then
              masterfip_macrocyc_lgth_int <= wrdata_reg(30 downto 0);
              masterfip_macrocyc_start_int <= wrdata_reg(31);
            end if;
            rddata_reg(30 downto 0) <= masterfip_macrocyc_lgth_int;
            rddata_reg(31) <= '0';
            ack_sreg(2) <= '1';
            ack_in_progress <= '1';
          when "00001011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(30 downto 0) <= regs_i.macrocyc_time_cnt_i;
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00001100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.macrocyc_num_cnt_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00001101" => 
            if (wb_we_i = '1') then
              masterfip_turnar_lgth_int <= wrdata_reg(30 downto 0);
              masterfip_turnar_start_int <= wrdata_reg(31);
            end if;
            rddata_reg(30 downto 0) <= masterfip_turnar_lgth_int;
            rddata_reg(31) <= '0';
            ack_sreg(2) <= '1';
            ack_in_progress <= '1';
          when "00001110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(30 downto 0) <= regs_i.turnar_time_cnt_i;
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00001111" => 
            if (wb_we_i = '1') then
              masterfip_silen_lgth_int <= wrdata_reg(30 downto 0);
              masterfip_silen_start_int <= wrdata_reg(31);
            end if;
            rddata_reg(30 downto 0) <= masterfip_silen_lgth_int;
            rddata_reg(31) <= '0';
            ack_sreg(2) <= '1';
            ack_in_progress <= '1';
          when "00010000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(30 downto 0) <= regs_i.silen_time_cnt_i;
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00010001" => 
            if (wb_we_i = '1') then
              masterfip_tx_ctrl_rst_int <= wrdata_reg(0);
              masterfip_tx_ctrl_start_int <= wrdata_reg(1);
              masterfip_tx_ctrl_bytes_num_int <= wrdata_reg(23 downto 8);
            end if;
            rddata_reg(0) <= '0';
            rddata_reg(1) <= '0';
            rddata_reg(23 downto 8) <= masterfip_tx_ctrl_bytes_num_int;
            rddata_reg(2) <= 'X';
            rddata_reg(3) <= 'X';
            rddata_reg(4) <= 'X';
            rddata_reg(5) <= 'X';
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(2) <= '1';
            ack_in_progress <= '1';
          when "00010010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(0) <= regs_i.tx_stat_stop_i;
            rddata_reg(8) <= regs_i.tx_stat_ena_i;
            rddata_reg(31 downto 16) <= regs_i.tx_stat_curr_byte_indx_i;
            rddata_reg(1) <= 'X';
            rddata_reg(2) <= 'X';
            rddata_reg(3) <= 'X';
            rddata_reg(4) <= 'X';
            rddata_reg(5) <= 'X';
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00010011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(0) <= regs_i.fd_wdg_i;
            rddata_reg(1) <= regs_i.fd_cd_i;
            rddata_reg(2) <= 'X';
            rddata_reg(3) <= 'X';
            rddata_reg(4) <= 'X';
            rddata_reg(5) <= 'X';
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00010100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.fd_wdg_tstamp_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00010101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.fd_txer_cnt_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00010110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.fd_txer_tstamp_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00010111" => 
            if (wb_we_i = '1') then
              masterfip_rx_ctrl_rst_int <= wrdata_reg(0);
            end if;
            rddata_reg(0) <= '0';
            rddata_reg(1) <= 'X';
            rddata_reg(2) <= 'X';
            rddata_reg(3) <= 'X';
            rddata_reg(4) <= 'X';
            rddata_reg(5) <= 'X';
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(2) <= '1';
            ack_in_progress <= '1';
          when "00011000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(0) <= regs_i.rx_stat_pream_ok_i;
            rddata_reg(1) <= regs_i.rx_stat_ctrl_byte_ok_i;
            rddata_reg(2) <= regs_i.rx_stat_frame_ok_i;
            rddata_reg(3) <= regs_i.rx_stat_frame_crc_err_i;
            rddata_reg(4) <= regs_i.rx_stat_bytes_num_err_i;
            rddata_reg(23 downto 8) <= regs_i.rx_stat_bytes_num_i;
            rddata_reg(5) <= 'X';
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00011001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= regs_i.rx_stat_curr_word_indx_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00011010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_stat_crc_err_cnt_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00011011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= regs_i.rx_payld_ctrl_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00011100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg1_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00011101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg2_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00011110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg3_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00011111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg4_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00100000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg5_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00100001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg6_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00100010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg7_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00100011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg8_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00100100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg9_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00100101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg10_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00100110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg11_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00100111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg12_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00101000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg13_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00101001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg14_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00101010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg15_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00101011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg16_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00101100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg17_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00101101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg18_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00101110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg19_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00101111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg20_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00110000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg21_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00110001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg22_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00110010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg23_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00110011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg24_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00110100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg25_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00110101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg26_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00110110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg27_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00110111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg28_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00111000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg29_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00111001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg30_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00111010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg31_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00111011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg32_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00111100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg33_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00111101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg34_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00111110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg35_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00111111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg36_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01000000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg37_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01000001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg38_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01000010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg39_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01000011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg40_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01000100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg41_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01000101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg42_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01000110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg43_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01000111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg44_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01001000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg45_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01001001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg46_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01001010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg47_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01001011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg48_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01001100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg49_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01001101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg50_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01001110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg51_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01001111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg52_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01010000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg53_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01010001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg54_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01010010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg55_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01010011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg56_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01010100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg57_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01010101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg58_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01010110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg59_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01010111" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg60_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01011000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg61_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01011001" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg62_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01011010" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg63_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01011011" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg64_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01011100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg65_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01011101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg66_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01011110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= regs_i.rx_payld_reg67_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01011111" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_ctrl_int <= wrdata_reg(7 downto 0);
            end if;
            rddata_reg(7 downto 0) <= masterfip_tx_payld_ctrl_int;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01100000" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg1_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg1_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01100001" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg2_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg2_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01100010" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg3_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg3_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01100011" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg4_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg4_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01100100" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg5_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg5_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01100101" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg6_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg6_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01100110" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg7_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg7_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01100111" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg8_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg8_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01101000" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg9_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg9_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01101001" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg10_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg10_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01101010" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg11_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg11_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01101011" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg12_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg12_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01101100" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg13_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg13_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01101101" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg14_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg14_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01101110" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg15_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg15_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01101111" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg16_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg16_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01110000" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg17_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg17_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01110001" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg18_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg18_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01110010" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg19_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg19_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01110011" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg20_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg20_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01110100" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg21_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg21_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01110101" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg22_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg22_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01110110" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg23_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg23_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01110111" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg24_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg24_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01111000" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg25_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg25_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01111001" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg26_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg26_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01111010" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg27_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg27_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01111011" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg28_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg28_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01111100" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg29_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg29_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01111101" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg30_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg30_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01111110" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg31_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg31_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01111111" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg32_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg32_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10000000" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg33_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg33_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10000001" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg34_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg34_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10000010" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg35_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg35_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10000011" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg36_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg36_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10000100" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg37_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg37_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10000101" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg38_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg38_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10000110" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg39_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg39_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10000111" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg40_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg40_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10001000" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg41_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg41_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10001001" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg42_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg42_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10001010" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg43_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg43_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10001011" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg44_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg44_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10001100" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg45_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg45_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10001101" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg46_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg46_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10001110" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg47_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg47_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10001111" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg48_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg48_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10010000" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg49_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg49_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10010001" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg50_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg50_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10010010" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg51_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg51_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10010011" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg52_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg52_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10010100" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg53_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg53_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10010101" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg54_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg54_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10010110" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg55_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg55_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10010111" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg56_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg56_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10011000" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg57_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg57_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10011001" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg58_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg58_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10011010" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg59_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg59_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10011011" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg60_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg60_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10011100" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg61_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg61_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10011101" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg62_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg62_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10011110" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg63_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg63_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10011111" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg64_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg64_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10100000" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg65_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg65_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10100001" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg66_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg66_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10100010" => 
            if (wb_we_i = '1') then
              masterfip_tx_payld_reg67_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= masterfip_tx_payld_reg67_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when others =>
-- prevent the slave from hanging the bus on invalid address
            ack_in_progress <= '1';
            ack_sreg(0) <= '1';
          end case;
        end if;
      end if;
    end if;
  end process;
  
  
-- Drive the data output bus
  wb_dat_o <= rddata_reg;
-- Version identifier
  regs_o.ver_id_o <= masterfip_ver_id_int;
-- reset of the masterFIP core
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      masterfip_rst_core_dly0 <= '0';
      regs_o.rst_core_o <= '0';
    elsif rising_edge(clk_sys_i) then
      masterfip_rst_core_dly0 <= masterfip_rst_core_int;
      regs_o.rst_core_o <= masterfip_rst_core_int and (not masterfip_rst_core_dly0);
    end if;
  end process;
  
  
-- reset of the FielDrive chip
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      masterfip_rst_fd_dly0 <= '0';
      regs_o.rst_fd_o <= '0';
    elsif rising_edge(clk_sys_i) then
      masterfip_rst_fd_dly0 <= masterfip_rst_fd_int;
      regs_o.rst_fd_o <= masterfip_rst_fd_int and (not masterfip_rst_fd_dly0);
    end if;
  end process;
  
  
-- rx act green led
  regs_o.led_rx_act_o <= masterfip_led_rx_act_int;
-- rx err red led
  regs_o.led_rx_err_o <= masterfip_led_rx_err_int;
-- tx act green led
  regs_o.led_tx_act_o <= masterfip_led_tx_act_int;
-- tx err red led
  regs_o.led_tx_err_o <= masterfip_led_tx_err_int;
-- ext sync act green led
  regs_o.led_ext_sync_act_o <= masterfip_led_ext_sync_act_int;
-- ext sync err red led
  regs_o.led_ext_sync_err_o <= masterfip_led_ext_sync_err_int;
-- dbg
  regs_o.led_dbg_o <= masterfip_led_dbg_int;
-- ds1820 temperature
-- ds1820 id lsb
-- ds1820 id msb
-- termination enable
  regs_o.ext_sync_ctrl_term_en_o <= masterfip_ext_sync_ctrl_term_en_int;
-- transceiver direction
  regs_o.ext_sync_ctrl_dir_o <= masterfip_ext_sync_ctrl_dir_int;
-- transceiver output enable negative logic
  regs_o.ext_sync_ctrl_oe_n_o <= masterfip_ext_sync_ctrl_oe_n_int;
-- pulses counter reset
  regs_o.ext_sync_ctrl_p_cnt_rst_o <= masterfip_ext_sync_ctrl_p_cnt_rst_int;
-- counting options
  regs_o.ext_sync_ctrl_opt_o <= masterfip_ext_sync_ctrl_opt_int;
-- safe window
  regs_o.ext_sync_ctrl_safe_wind_o <= masterfip_ext_sync_ctrl_safe_wind_int;
-- ext_sync_p_cnt
-- WorldFIP speed, hard-wired on the FMC
-- macrocycle lgth
  regs_o.macrocyc_lgth_o <= masterfip_macrocyc_lgth_int;
-- macrocycle cnt start
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      masterfip_macrocyc_start_dly0 <= '0';
      regs_o.macrocyc_start_o <= '0';
    elsif rising_edge(clk_sys_i) then
      masterfip_macrocyc_start_dly0 <= masterfip_macrocyc_start_int;
      regs_o.macrocyc_start_o <= masterfip_macrocyc_start_int and (not masterfip_macrocyc_start_dly0);
    end if;
  end process;
  
  
-- macrocycle time counter
-- number of macrocycles
-- turnaround time
  regs_o.turnar_lgth_o <= masterfip_turnar_lgth_int;
-- turnaround cnt start
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      masterfip_turnar_start_dly0 <= '0';
      regs_o.turnar_start_o <= '0';
    elsif rising_edge(clk_sys_i) then
      masterfip_turnar_start_dly0 <= masterfip_turnar_start_int;
      regs_o.turnar_start_o <= masterfip_turnar_start_int and (not masterfip_turnar_start_dly0);
    end if;
  end process;
  
  
-- turnaround time counter
-- silence time
  regs_o.silen_lgth_o <= masterfip_silen_lgth_int;
-- silence cnt start
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      masterfip_silen_start_dly0 <= '0';
      regs_o.silen_start_o <= '0';
    elsif rising_edge(clk_sys_i) then
      masterfip_silen_start_dly0 <= masterfip_silen_start_int;
      regs_o.silen_start_o <= masterfip_silen_start_int and (not masterfip_silen_start_dly0);
    end if;
  end process;
  
  
-- silence time counter
-- tx rst
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      masterfip_tx_ctrl_rst_dly0 <= '0';
      regs_o.tx_ctrl_rst_o <= '0';
    elsif rising_edge(clk_sys_i) then
      masterfip_tx_ctrl_rst_dly0 <= masterfip_tx_ctrl_rst_int;
      regs_o.tx_ctrl_rst_o <= masterfip_tx_ctrl_rst_int and (not masterfip_tx_ctrl_rst_dly0);
    end if;
  end process;
  
  
-- tx strt
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      masterfip_tx_ctrl_start_dly0 <= '0';
      regs_o.tx_ctrl_start_o <= '0';
    elsif rising_edge(clk_sys_i) then
      masterfip_tx_ctrl_start_dly0 <= masterfip_tx_ctrl_start_int;
      regs_o.tx_ctrl_start_o <= masterfip_tx_ctrl_start_int and (not masterfip_tx_ctrl_start_dly0);
    end if;
  end process;
  
  
-- tx number of bytes
  regs_o.tx_ctrl_bytes_num_o <= masterfip_tx_ctrl_bytes_num_int;
-- tx ended
-- tx enable
-- tx status current byte index
-- FielDrive watchdog
-- FielDrive carrier detect
-- fd_wdgn_tstamp
-- fd_txer_cnt
-- fd_txer_tstamp
-- rx rst
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      masterfip_rx_ctrl_rst_dly0 <= '0';
      regs_o.rx_ctrl_rst_o <= '0';
    elsif rising_edge(clk_sys_i) then
      masterfip_rx_ctrl_rst_dly0 <= masterfip_rx_ctrl_rst_int;
      regs_o.rx_ctrl_rst_o <= masterfip_rx_ctrl_rst_int and (not masterfip_rx_ctrl_rst_dly0);
    end if;
  end process;
  
  
-- rx Preamble(FSS) detected
-- rx CTRL byte detected
-- rx frame ok
-- rx frame crc error
-- rx bytes number error
-- rx number of payload bytes
-- current word index
-- rx number of frames with CRC error
-- rx payload ctrl byte
-- reg 1
-- reg2
-- reg3
-- reg4
-- reg5
-- reg6
-- reg7
-- reg8
-- reg9
-- reg10
-- reg11
-- reg12
-- reg13
-- reg14
-- reg15
-- reg16
-- reg17
-- reg18
-- reg19
-- reg20
-- reg21
-- reg22
-- reg23
-- reg24
-- reg25
-- reg26
-- reg27
-- reg28
-- reg29
-- reg30
-- reg31
-- reg32
-- reg 33
-- reg34
-- reg35
-- reg36
-- reg37
-- reg38
-- reg39
-- reg40
-- reg41
-- reg42
-- reg43
-- reg44
-- reg45
-- reg46
-- reg47
-- reg48
-- reg49
-- reg50
-- reg51
-- reg52
-- reg53
-- reg54
-- reg55
-- reg56
-- reg57
-- reg58
-- reg59
-- reg60
-- reg61
-- reg62
-- reg63
-- reg64
-- reg65
-- reg66
-- reg67
-- tx ctrl byte
  regs_o.tx_payld_ctrl_o <= masterfip_tx_payld_ctrl_int;
-- reg1
  regs_o.tx_payld_reg1_o <= masterfip_tx_payld_reg1_int;
-- reg2
  regs_o.tx_payld_reg2_o <= masterfip_tx_payld_reg2_int;
-- reg3
  regs_o.tx_payld_reg3_o <= masterfip_tx_payld_reg3_int;
-- reg4
  regs_o.tx_payld_reg4_o <= masterfip_tx_payld_reg4_int;
-- reg5
  regs_o.tx_payld_reg5_o <= masterfip_tx_payld_reg5_int;
-- reg6
  regs_o.tx_payld_reg6_o <= masterfip_tx_payld_reg6_int;
-- reg7
  regs_o.tx_payld_reg7_o <= masterfip_tx_payld_reg7_int;
-- reg8
  regs_o.tx_payld_reg8_o <= masterfip_tx_payld_reg8_int;
-- reg9
  regs_o.tx_payld_reg9_o <= masterfip_tx_payld_reg9_int;
-- reg10
  regs_o.tx_payld_reg10_o <= masterfip_tx_payld_reg10_int;
-- reg11
  regs_o.tx_payld_reg11_o <= masterfip_tx_payld_reg11_int;
-- reg12
  regs_o.tx_payld_reg12_o <= masterfip_tx_payld_reg12_int;
-- reg13
  regs_o.tx_payld_reg13_o <= masterfip_tx_payld_reg13_int;
-- reg14
  regs_o.tx_payld_reg14_o <= masterfip_tx_payld_reg14_int;
-- reg15
  regs_o.tx_payld_reg15_o <= masterfip_tx_payld_reg15_int;
-- reg16
  regs_o.tx_payld_reg16_o <= masterfip_tx_payld_reg16_int;
-- reg17
  regs_o.tx_payld_reg17_o <= masterfip_tx_payld_reg17_int;
-- reg18
  regs_o.tx_payld_reg18_o <= masterfip_tx_payld_reg18_int;
-- reg19
  regs_o.tx_payld_reg19_o <= masterfip_tx_payld_reg19_int;
-- reg20
  regs_o.tx_payld_reg20_o <= masterfip_tx_payld_reg20_int;
-- reg21
  regs_o.tx_payld_reg21_o <= masterfip_tx_payld_reg21_int;
-- reg22
  regs_o.tx_payld_reg22_o <= masterfip_tx_payld_reg22_int;
-- reg23
  regs_o.tx_payld_reg23_o <= masterfip_tx_payld_reg23_int;
-- reg24
  regs_o.tx_payld_reg24_o <= masterfip_tx_payld_reg24_int;
-- reg25
  regs_o.tx_payld_reg25_o <= masterfip_tx_payld_reg25_int;
-- reg26
  regs_o.tx_payld_reg26_o <= masterfip_tx_payld_reg26_int;
-- reg27
  regs_o.tx_payld_reg27_o <= masterfip_tx_payld_reg27_int;
-- reg28
  regs_o.tx_payld_reg28_o <= masterfip_tx_payld_reg28_int;
-- reg29
  regs_o.tx_payld_reg29_o <= masterfip_tx_payld_reg29_int;
-- reg30
  regs_o.tx_payld_reg30_o <= masterfip_tx_payld_reg30_int;
-- reg31
  regs_o.tx_payld_reg31_o <= masterfip_tx_payld_reg31_int;
-- reg32
  regs_o.tx_payld_reg32_o <= masterfip_tx_payld_reg32_int;
-- reg 33
  regs_o.tx_payld_reg33_o <= masterfip_tx_payld_reg33_int;
-- reg34
  regs_o.tx_payld_reg34_o <= masterfip_tx_payld_reg34_int;
-- reg35
  regs_o.tx_payld_reg35_o <= masterfip_tx_payld_reg35_int;
-- reg36
  regs_o.tx_payld_reg36_o <= masterfip_tx_payld_reg36_int;
-- reg37
  regs_o.tx_payld_reg37_o <= masterfip_tx_payld_reg37_int;
-- reg38
  regs_o.tx_payld_reg38_o <= masterfip_tx_payld_reg38_int;
-- reg39
  regs_o.tx_payld_reg39_o <= masterfip_tx_payld_reg39_int;
-- reg40
  regs_o.tx_payld_reg40_o <= masterfip_tx_payld_reg40_int;
-- reg41
  regs_o.tx_payld_reg41_o <= masterfip_tx_payld_reg41_int;
-- reg42
  regs_o.tx_payld_reg42_o <= masterfip_tx_payld_reg42_int;
-- reg43
  regs_o.tx_payld_reg43_o <= masterfip_tx_payld_reg43_int;
-- reg44
  regs_o.tx_payld_reg44_o <= masterfip_tx_payld_reg44_int;
-- reg45
  regs_o.tx_payld_reg45_o <= masterfip_tx_payld_reg45_int;
-- reg46
  regs_o.tx_payld_reg46_o <= masterfip_tx_payld_reg46_int;
-- reg47
  regs_o.tx_payld_reg47_o <= masterfip_tx_payld_reg47_int;
-- reg48
  regs_o.tx_payld_reg48_o <= masterfip_tx_payld_reg48_int;
-- reg49
  regs_o.tx_payld_reg49_o <= masterfip_tx_payld_reg49_int;
-- reg50
  regs_o.tx_payld_reg50_o <= masterfip_tx_payld_reg50_int;
-- reg51
  regs_o.tx_payld_reg51_o <= masterfip_tx_payld_reg51_int;
-- reg52
  regs_o.tx_payld_reg52_o <= masterfip_tx_payld_reg52_int;
-- reg53
  regs_o.tx_payld_reg53_o <= masterfip_tx_payld_reg53_int;
-- reg54
  regs_o.tx_payld_reg54_o <= masterfip_tx_payld_reg54_int;
-- reg55
  regs_o.tx_payld_reg55_o <= masterfip_tx_payld_reg55_int;
-- reg56
  regs_o.tx_payld_reg56_o <= masterfip_tx_payld_reg56_int;
-- reg57
  regs_o.tx_payld_reg57_o <= masterfip_tx_payld_reg57_int;
-- reg58
  regs_o.tx_payld_reg58_o <= masterfip_tx_payld_reg58_int;
-- reg59
  regs_o.tx_payld_reg59_o <= masterfip_tx_payld_reg59_int;
-- reg60
  regs_o.tx_payld_reg60_o <= masterfip_tx_payld_reg60_int;
-- reg61
  regs_o.tx_payld_reg61_o <= masterfip_tx_payld_reg61_int;
-- reg62
  regs_o.tx_payld_reg62_o <= masterfip_tx_payld_reg62_int;
-- reg63
  regs_o.tx_payld_reg63_o <= masterfip_tx_payld_reg63_int;
-- reg64
  regs_o.tx_payld_reg64_o <= masterfip_tx_payld_reg64_int;
-- reg65
  regs_o.tx_payld_reg65_o <= masterfip_tx_payld_reg65_int;
-- reg66
  regs_o.tx_payld_reg66_o <= masterfip_tx_payld_reg66_int;
-- reg67
  regs_o.tx_payld_reg67_o <= masterfip_tx_payld_reg67_int;
  rwaddr_reg <= wb_adr_i;
  wb_stall_o <= (not ack_sreg(0)) and (wb_stb_i and wb_cyc_i);
-- ACK signal generation. Just pass the LSB of ACK counter.
  wb_ack_o <= ack_sreg(0);
end syn;

